# Makefile snippet included by projects using libt2n-codegen

# Asumptions: 
# gnu make (functions for transforming text)
# sed is available

include_HEADERS += $(foreach i, $(CMDGROUPS), $(i)_client.hxx $(i).hxx)

#IFILES=$(foreach i, $(CMDGROUPS), $(foreach j, $($(i)_GROUP), $(j)))

-include $(foreach i, $(CMDGROUPS), libt2ngroup_$(i).P)

libt2ngroup_%.P : Makefile.am
	echo $@ : $($*_GROUP) > libt2ngroup_$*.P

%.libt2nstamp : libt2ngroup_%.P $(LIBT2N_CODEGEN)
# assuming we have some unix like shell (maybe even bash)
	echo BUILT_SOURCES: $(BUILT_SOURCES)
# temporarily create _common.hxx file (will be overwritten by codegen below)
	echo '#include "codegen-stubhead.hxx"' > $*_common.hxx;
	echo '#include "$*.hxx"' >> $*_common.hxx;
# todo use tmp file for xml file
	for i in $($*_GROUP); do \
		gccxml $(DEFS) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) $(srcdir)/$${i} -fxml=$${i%*.cpp}.xml; \
	done; \
	$(LIBT2N_CODEGEN) $* $($*_GROUP:.cpp=.xml) && touch $@

LIBT2N_CODEGEN_BUILT = $(foreach i, $(CMDGROUPS), $(foreach j, _common.hxx _common.cpp _client.hxx _client.cpp _server.hxx _server.cpp, $(i)$(j)) )
BUILT_SOURCES = $(LIBT2N_CODEGEN_BUILT)

STAMPS=$(CMDGROUPS:=.libt2nstamp)
$(BUILT_SOURCES) : $(STAMPS)

# Install the pkg-config files:
pkgconfigdir = $(libdir)/pkgconfig
pkgconfig_DATA = $(CMDGROUPS:=.pc)

# .pc files (one pc file for each command group)
%.pc : $(LIBT2N_CLIENT_PCTEMPLATE) Makefile
	sed \
	-e 's,@CMDGROUP@,$*,g' \
	-e 's,\@prefix\@,$(prefix),g' \
	-e 's,\@exec_prefix\@,$(exec_prefix),g' \
	-e 's,\@libdir\@,$(libdir),g' \
	-e 's,\@includedir\@,$(includedir),g' \
	$< >$*.pc

CLEANFILES = $(BUILT_SOURCES) $(STAMPS) $(pkgconfig_DATA)

# didn't work (same problem as with _LTLIBRARIES [parsing by automake],
# this time _OBJECTS was not correct)
# server_SOURCES = server.cpp \
#	$(foreach i, $(CMDGROUPS), $(foreach j, $($(i)_GROUP), $(j))) \
#	$(foreach i, $(CMDGROUPS), $(i)_server.cpp)

# we have got an old automake version (1.4-p5) which doesn't support nodist_
# => we use the dist-hook
# unfortunately dist-hook only works if directly visible for automake (=> not in this include)
#dist-hook:
#	rm -vf $(foreach i, $(BUILT_SOURCES), $(distdir)/$(i))
